#!/usr/bin/perl
#------------------------------------------------------------
#Usage: $prgName output (from glove)
#------------------------------------------------------------
if ($ARGV[0] eq "-help" or $#ARGV < 0) { die "
USAGE:   $0 curvefit.results
\n";
}

$filea = $ARGV[0];
$count=0;

################################################################################
#Read in Data
open(INA, $filea) || die "Can't open file $filea.\n";
while($line = <INA>){
  # $line =~ s/^\s+//;
   @field = split(/\s+/,$line);
  chop($line);

CHECK: {
if ($line=~ /SET\s+/) {
$vector = $field[1];
($res,$atom) = split(/-/,$vector);
}

#Get Rate:
if ($line=~ /B\s+/) {
$data{$res}{$atom}{B} = $field[2];
$data{$res}{$atom}{B_err} = $field[3];
}

if ($line=~ /X2red/ and $line!~ /Global/ and $line!~ /#/)  {
#print "$line\n"; 
$data{$res}{$atom}{x2} = $field[2];
$data{$res}{$atom}{x2_err} = $field[3];
  }
 }
}
close(INA);

######################################################################
# get peak lists from 1D .xpk
$i=0;
open LIST2, $ARGV[1];
while (defined($line = <LIST2>)) {;
        @fields = split(/\s+/, $line);
                        $peak[$i] = $fields[0];
                        $ppm{$i} =  $fields[1];
                        $i += 1;
                        $numpks=$i;
                        };
                        close LIST2;
#######################################################################
### PRINT OUTPUT
                printf "Peak#	Integral_range	(1/k)(min) error X2red\n" ;
foreach $res ( sort numerically keys %data ) {
        foreach $atom ( sort keys %{ $data{$res} } ) {
$B = $data{$res}{$atom}{B};
$B_err = $data{$res}{$atom}{B_err};
$chi2 = $data{$res}{$atom}{x2};

$rate = 1/abs($B);

$ppm=$ppm{$res};
                printf "%d\t",$res ;
		$B_err = substr($B_err,1); # remove first character of string
		$B_err = substr($B_err,0,-1); #remove last char of string 
$drate = $rate*abs($B_err/$B);
                printf "%s\t", $ppm;
                printf "%5.2f\t", $rate;
                printf "%5.2f\t", $drate;
                printf "%5.3f\n", $chi2;
}
}

exit;
sub numerically { $a <=> $b; }
