#!/usr/bin/perl

#generate 'Int' file for glove;
#file reads in pklist for integral ranges (8-11 or 11-8, order doesn't matter) 
#also reads in ?.dat ??.dat files which are the spectra in txt format from pipe2txt.tcl script.
# note header vals are generated within (below) and should be edited accordingly for each dosy setup
#
# USAGE makeIntegral man.xpk >Int

use Math::Trig;

$pi = 3.141592653;
$scale=1;
$inc=0.5;  #time between expts; eg 30 seconds


# OUTPUT Files generated
$outfile1="Int";
$outfile2="excel.txt";
open(OUTPUT, "> $outfile1");
open(OUTPUT2, "> $outfile2");

# get peak lists from 1D .xpk
open LIST, $ARGV[0];
$i = 0;
while (defined($line = <LIST>)) {;
	@fields = split(/\s+/, $line);
			$peak[$i] = $fields[0];
			($a[$i], $b[$i]) = split(/:/, $fields[1]);
    			if ($a==$b){                     
			$high[$i]=$a[$i];
			$low[$i]=$b[$i];}
    			if ($a[$i]>$b[$i]){                     
			$high[$i]=$a[$i];
			$low[$i]=$b[$i];}
			else{
			$high[$i]=$b[$i];
			$low[$i]=$a[$i];
			}
                        $high[$i] = sprintf("%.3f", $high[$i]);
                        $low[$i] = sprintf("%.3f", $low[$i]);
#			print "i is $i, peak $peak[$i], ppm is $high[$i] $low[$i]\n";
			$i += 1;
			$numpks=$i;
};
#			print "number of pks $numpks\n";
close LIST;

#get list of files in directory named .dat
opendir(DIR,".") ;
@files = grep(/\.dat$/,readdir(DIR));
closedir(DIR);

# print all the filenames in our array
foreach $file (@files) {
split(/\s+/,);
($filnum,$junk) = split(/\./,$file);
#print "filnumber is $filnum\n";

	open(INA, $file) || die "Can't open file $filea.\n";

	while($line = <INA>){
	@val = split(/\s+/,$line);
        chop($line);
   	$ppm{$filnum}{$count} = $val[1];
   	$int{$filnum}{$count} = $val[2]/$scale;
   	$count=$count+1;
    #   print " $count  $val[1] $val[2]\n";
	}
	close(INA);
        $count=0;
}

$numfiles=@files;


######## Create tau values for header 
for ($i=0; $i < $numfiles; $i++){
   printf OUTPUT "%3.4f ",$i*$inc;
   }
      printf OUTPUT "\n";

##################

#SORT all files according to number and print
for ($i=0; $i < $numpks; $i++){
foreach $filnum ( sort numerically keys %ppm ) {
foreach $count ( sort numerically keys %{$ppm{$filnum} } ) {
    if ($ppm{$filnum}{$count} < $high[$i] && $ppm{$filnum}{$count}> $low[$i] && $filnum > 0){
#       printf "%7.3f ", $ppm{$filnum}{$count};
#       printf "%7.0f ", $int{$filnum}{$count};
#       printf "%7.0f ", $i;
#       printf "%7.0f ", $filnum;
       $add[$i][$filnum] =$add[$i][$filnum] +  $int{$filnum}{$count};
#       printf "%7.0f\n ", $add[$i][$filnum];
}
}
}
}
######################################
# PRINT OUT INTEGRATED VALUES
#print scalar(@files);



$numfiles=@files;
###############################################
# print out integrated peaks for "Int"
#
for ($i=0; $i < $numpks; $i++){
       printf OUTPUT "%4.0f %4.0f HN ",$i, $i;
for ($x=1; $x<= $numfiles; $x++){
#normalize to first or last pt; whichever is greatest
if (abs($add[$i][1]) > abs($add[$i][$numfiles])) {$norm = $add[$i][1]}
else {$norm = $add[$i][$numfiles]}
       printf OUTPUT "%2.5f ", $add[$i][$x]/$norm;
       #printf "%2.5f ", $add[$i][$x]/$add[$i][1];
       #printf "%2.5f ", $add[$i][$x];
}
       print OUTPUT "\n";
}
######################################################

#####################################################
#Print out excel.txt file
for ($x=1; $x<= $numfiles; $x++){
   $g=$x*$inc;
   printf OUTPUT2 "%3.2f ",$g;

for ($i=0; $i < $numpks; $i++){
if (abs($add[$i][1]) > abs($add[$i][$numfiles])) {$norm = $add[$i][1]}
else {$norm = $add[$i][$numfiles]}
       printf  OUTPUT2 "%5.3f\t", $add[$i][$x]/$norm;
}
       print  OUTPUT2 "\n";
}
###################################3
exit;

sub numerically { $a <=> $b; }
